// SDI_ListViewView.cpp : Implementierung der Klasse CSDI_ListViewView
//

#include "stdafx.h"
#include "SDI_ListView.h"

#include "SDI_ListViewDoc.h"
#include "SDI_ListViewView.h"

//using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSDI_ListViewView

IMPLEMENT_DYNCREATE(CSDI_ListViewView, CListView)

BEGIN_MESSAGE_MAP(CSDI_ListViewView, CListView)
	//{{AFX_MSG_MAP(CSDI_ListViewView)
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO, OnGetdispinfo)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int CSDI_ListViewView::prevSort = -1;


// CSDI_ListViewView-Erstellung/Zerstrung

CSDI_ListViewView::CSDI_ListViewView()
{
	// TODO: Hier Code zur Konstruktion einfgen
	// prevSort = -1;

}

CSDI_ListViewView::~CSDI_ListViewView()
{
}

BOOL CSDI_ListViewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.
	cs.style &= ~LVS_TYPEMASK;
	cs.style |= LVS_REPORT;

	return CListView::PreCreateWindow(cs);
}

void CSDI_ListViewView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();


    GetListCtrl ().InsertColumn (0, "Name", LVCFMT_LEFT, 200);
    GetListCtrl ().InsertColumn (1, "Matrnr", LVCFMT_LEFT, 80);
    GetListCtrl ().InsertColumn (2, "Prfung", LVCFMT_LEFT, 200);
    GetListCtrl ().InsertColumn (3, "Note", LVCFMT_RIGHT, 100);

	addItem(0, "Schmidt", 14721, "Grundlagen der Informatik 2",2.7);
	addItem(1, "Meier", 17721, "betriebssysteme",1.0);
	addItem(2, "Bischoff", 17656, "Grundlagen der Informatik 2",2.0);
	addItem(3, "Dion", 12743, "Parallele Algorithmen",5.0);
}


BOOL CSDI_ListViewView::addItem(int Index,
		CString     sName,
		unsigned int Matrnr,
		CString 	sPruefung,
		double 		note ) 
{
	tableITEMINFO * pItem;
    // ITEMINFO-Struktur dynamisch anfordern und initialisieren
    try {
        pItem = new tableITEMINFO;
    }
    catch (CMemoryException* e) {
        e->Delete ();
		AfxMessageBox("Fehler in addItem");
        return FALSE;
    }

	pItem->sName = sName;
	pItem->Matrnr = Matrnr;
	pItem->sPruefung = sPruefung;
	pItem->note = note;


    // Eintrag in Liste-Steuerelement einfgen
    LV_ITEM lvi;
    lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM; 
    //lvi.mask = LVIF_TEXT | LVIF_PARAM; 
    lvi.iItem = Index; 
    lvi.iSubItem = 0; 
    lvi.iImage = 0;
    lvi.pszText = LPSTR_TEXTCALLBACK; 
    lvi.lParam = (LPARAM) pItem;	// Eintragen in Tabelle

    if (GetListCtrl ().InsertItem (&lvi) == -1) {
		AfxMessageBox("Fehler");
        return FALSE;
	}	
    return TRUE;
} // addItem


void CSDI_ListViewView::OnGetdispinfo(NMHDR* pNMHDR, LRESULT* pResult) {
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	CString str;
	//AfxMessageBox("GetDispInfo");
	
    if (pDispInfo->item.mask & LVIF_TEXT) {
        tableITEMINFO* pItem = (tableITEMINFO*) pDispInfo->item.lParam;

        switch (pDispInfo->item.iSubItem) {

        case 0: // Name
            ::lstrcpy (pDispInfo->item.pszText, pItem->sName);
            break;
        case 1: // Matrnr
            str.Format (_T ("%d"), pItem->Matrnr);
            ::lstrcpy (pDispInfo->item.pszText, str);
            break;
        case 2: // sPruefung
            ::lstrcpy (pDispInfo->item.pszText, pItem->sPruefung);
            break;
        case 3: // Note
            str.Format (_T ("%4.1f"), pItem->note);
            ::lstrcpy (pDispInfo->item.pszText, str);
            break;
        }
    }
	
	*pResult = 0;
}

void CSDI_ListViewView ::OnColumnClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
    NM_LISTVIEW* pNMListView = (NM_LISTVIEW*) pNMHDR;
    GetListCtrl ().SortItems (CompareFunc, pNMListView->iSubItem);
	if 	(prevSort == pNMListView->iSubItem)
		prevSort = -1;
	else
		prevSort = pNMListView->iSubItem;
    *pResult = 0;
}

// wenn -1  dann ist der erste Wert grer
// wenn +1  dann ist der zweite Wert grer
// wenn 0, dann sind beide Werte gleich
int CALLBACK CSDI_ListViewView::CompareFunc (
LPARAM lParam1, LPARAM lParam2,  LPARAM lParamSort)
{
	tableITEMINFO* pItem1 = (tableITEMINFO*) lParam1;
    tableITEMINFO* pItem2 = (tableITEMINFO*) lParam2;
    int nResult;

    switch (lParamSort) {
    case 0: // name
		nResult = pItem1->sName.CompareNoCase (pItem2->sName);
		//nResult = strcmp(pItem1->sName.GetBuffer(), pItem2->sName.GetBuffer() );
        break;

    case 1: // Matrnr
        nResult = pItem1->Matrnr - pItem2->Matrnr;
        break;

    case 2: // Prfung
		nResult = pItem1->sPruefung.CompareNoCase (pItem2->sPruefung);
		// nResult = strcmp(pItem1->sPruefung.GetBuffer(), pItem2->sPruefung.GetBuffer() );		
        break;
    case 3: // Note
        double n1, n2;
		n1 = pItem1->note;
		n2 = pItem2->note;
		if (n1<n2)
			nResult=1;
		else
			if (n1>n2)
				nResult=-1;
			else
				nResult=0;		
        break;
    }
	// war ein Doppelklick schon vorher mit dieser Spalte
	// dann umgekehrte Reihenfolge
	if (prevSort == lParamSort)
		nResult = -nResult;
	return nResult;
}


// CSDI_ListViewView-Diagnose

#ifdef _DEBUG
void CSDI_ListViewView::AssertValid() const
{
	CListView::AssertValid();
}

void CSDI_ListViewView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CSDI_ListViewDoc* CSDI_ListViewView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSDI_ListViewDoc)));
	return (CSDI_ListViewDoc*)m_pDocument;
}
#endif //_DEBUG


// CSDI_ListViewView-Meldungshandler
